/**
 * Class to play the Bingo game
 * @author Barb Ericson
 * Copyright 2006
 */
public class Bingo
{
  /////////////// fields //////////////

  /** the thing that holds and picks the balls */
  private BingoBallPicker picker = null;
  
  /** an array of the cards in the game */
  private BingoCard[] cardArray = null;
  
  /** the number of cards in the game */
  private int numCards = 5;
  
  //////////////// Constructor //////////////
  
  /**
   * Constructor that takes no arguments
   * It creates the ball picker which
   * creates the balls and then creates 
   * the bingo cards
   */
  public Bingo()
  {
    picker = new BingoBallPicker();
    cardArray = new BingoCard[numCards];
    for (int i = 0; i < cardArray.length; i++)
      cardArray[i] = new BingoCard();
  }
  
  ///////////////// methods /////////////////
  
  /**
   * Method to play the bingo game until a card
   * gets bingo
   */
  public void playGame()
  {
    BingoCard winningCard = null;
    boolean won = false;
    BingoBall ball = null;
    
    while (! won)
    {
       ball = picker.pickBall();
       System.out.print(ball+ " ");
       for (int i = 0; 
            i < cardArray.length; 
            i++)
       {
         won = cardArray[i].addBall(ball);
         if (won) 
         {
           winningCard = cardArray[i];
           break;
         }
       }
    }
    System.out.println("It took " +
                       picker.getNumPicked()+
                       " balls");
    System.out.println(winningCard);
  }
  
  public static void main(String[] args)
  {
    Bingo game = new Bingo();
    game.playGame();
  }

}