/**
 * Class that represents a bingo ball.  It has a 
 * number and letter.
 * @author Barb Ericson
 * Copyright 2006
 */
public class BingoBall implements Comparable
{
  ////////////// fields /////////////////
  
  /** the number on this ball */
  private int number;
  
  /** a number that matches a letter on the ball */
  private int letterNum;
  
  /** constant for the letter B */
  public static final int B = 0;
  
  /** constant for the letter I */
  public static final int I = 1;
  
  /** constant for the letter N */
  public static final int N = 2;
  
  /** constant for the letter G */
  public static final int G = 3;
  
  /** constant for the letter O */
  public static final int O = 4;
  
  /** array for bingo letters */
  public static final char[] letterArray = 
  {'B','I','N','G','O'};
  
  /////////////// constructors //////////
  
  /**
   * Constructor that takes a number and letter
   * number
   * @param theNumber the number on the ball
   * @param theLetterNum the number for the letter
   */
  public BingoBall(int theNumber,
                   int theLetterNum)
  {
    this.number = theNumber;
    this.letterNum = theLetterNum;
  }
  
  ///////////////// methods //////////////
  
  /**
   * Method to get the number on the ball 
   * @return the number on the ball
   */
  public int getNumber() 
  { return this.number;}
  
  /**
   * Method to return the letter on the ball
   * @return the letter on the ball
   */
  public char getLetter()
  {
    return this.letterArray[this.letterNum];
  }
  
  /**
   * Method to get the letter number 
   * @return the number for the letter on
   * the ball
   */
  public int getLetterNum()
  {
    return this.letterNum;
  }
  
  /**
   * Compares two bingo balls
   * a bingo ball is equal to another
   * when they have the same letter num
   * and the same number
   */
  public int compareTo(Object ballObj)
  {
    BingoBall testBall = null;
    int result = 0;
    if (ballObj instanceof BingoBall)
    {
      testBall = (BingoBall) ballObj;
      result = this.getLetterNum() - 
        testBall.getLetterNum();
      if (result == 0)
      {
        result = this.getNumber() - 
          testBall.getNumber();
      }
    }
      return result;
  }
  
  /**
   * Method to return a string
   * with the letter and number 
   * of the ball
   * @return a string with the
   * letter and number for this ball
   */
  public String toString()
  {
    return this.getLetter() + 
      "-" + this.getNumber();
  }
}