import java.util.*;

/**
 * The bingo ball picker contains
 * all of the balls when it is first
 * created and a list of all of the picked
 * balls.  It has a method that allows you
 * to pick a ball.
 * @author Barb Ericson
 * Copyright 2006
 */
public class BingoBallPicker
{
  //////////// fields ///////////////////
  
  /** list of balls in picker still */
  private List<BingoBall> ballList = null;
  
  /** list of picked balls */
  private List<BingoBall> pickedBalls = 
    new ArrayList<BingoBall>();
  
  /** random number generator */
  private Random randNumGen = new Random();
  
  ///////////// constructors //////////////
  
  /** 
   * No agument constructor that creates
   * all the balls
   */
  public BingoBallPicker()
  {
    createBallList();
  }
  
  /**
   * Method that creates all the balls to
   * start
   */
  private void createBallList()
  {
    ballList = new ArrayList<BingoBall>();
    int number = 0;
    for (int let = 0; let < 5; let++)
    {
      for (int i = 1; i < 16; i++)
      {
        number = let * 15 + i;
        this.ballList.add(new BingoBall(number,
                                        let));
      }
    }
  }
  
  /**
   * method to return in a string
   * information about the balls in
   * the picker 
   */
  public String toString()
  {
    String result = "";
    for (BingoBall ball : this.ballList)
      result = result + ball.toString() + "\n";
    return result;
  }
  
  /**
   * Method to pick a ball from the picker.  It
   * will remove it from the list of balls in
   * the picker and put
   * it in the list of picked balls.
   * @return the picked ball
   */
  public BingoBall pickBall()
  {
    int index = randNumGen.nextInt(
                                  this.ballList.size());
    BingoBall ball = ballList.remove(index);
    pickedBalls.add(ball);
    return ball;
  }
  
  /**
   * Method to get a ball at the given index in
   * the picker (this does not remove it from
   * the picker)
   * @param index the position of the ball in 
   * the list of balls
   * @return the ball at the index or null
   * if the index is past the number of balls
   */
  public BingoBall getBall(int index)
  {
    if (index < ballList.size())
       return ballList.get(index);
    else
      return null;
  }
  
  /**
   * Method to return the number of balls
   * picked
   * @return the number of balls in the picked
   * list 
   */
  public int getNumPicked()
  {
    return pickedBalls.size();
  }
  
  public static void main(String[] args)
  {
    BingoBallPicker picker = new BingoBallPicker();
    System.out.println(picker);
  }
    
}