import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.KeyStroke;
import javax.swing.Timer;
 
/**
 * The GUI (View) portion of the code
 * This class will draw the elements of the game, when called by the
 * WarGame class (Controller)
 *
 * @author  Allison Jensen
 */
public class BlackJackGUI extends JFrame {
	
	private static final long serialVersionUID = 1;
	
	/**
	 * Reference to thw War model
	 */
	BlackJack gameLogic;
	
	/* Global variables to be used for the menu bar*/
	JMenuBar menuBar;
	JMenu menu;         
	JMenuItem menuItem1;
	JMenuItem menuItem2;
	JMenuItem menuItem3;
	JMenuItem menuItem4;
	
	/* The panels of the screen */
	JPanel myPanel; //The main panel	
	JLabel chip1;
	JLabel chip2;
	JLabel chip3;
	JLabel chip4;
	JLabel chip5;
	
	JLabel hitLabel;
	JLabel standLabel;
	JLabel dealLabel;
	
	JLabel playerHandValue;
	JLabel dealerHandValue;
	
	JLabel betAmount;
	JButton totalMoney;
	JButton betButton;
	int playerMoney;
	int playerBet;
	CardLabel [] playerHand = new CardLabel[22];
	CardLabel [] computerHand = new CardLabel[22];	
	
	CardLabel [] playerMoves = new CardLabel[5];
	CardLabel [] computerMoves = new CardLabel[5];
	
	CardLabel deck;
	
	boolean animating;
	boolean inRound;

	
	/* The timer variables */
	Timer timer;   					/* Timer for initial animation */ 
	Timer timer2;					/* Timer for moving cards to the won piles */
	Timer timer3;
	
	JLabel playerBust;
	JLabel playerWinner;
	JLabel dealerWinner;
	JLabel dealerBust;

	Player dealer;
	Player human;
	int displayCount;
	
	CardLabel movingCard;// = new CardLabel(50, 420, getImage(null));
	int animationStartX = 420;
	int animationStartY = 50;
	int xStepLength;
	int yStepLength;
	int endX;
	int endY;
	int numberOfSteps = 5;
	int stepCount;
	int dealCount = 2;
	int numberDealed = 0;
	boolean playerCardMoving;
	int locationMovingTo;
	boolean animationFinished = false;
	int count = 0;
	Card hitCard; 
	
	Hand playerCards;
	Hand dealerCards;
	int playerPileLocation;
	int dealerPileLocation;
	int dealerHitCount;
	
	
	/* Debugging Variable */
	private boolean debug = true;

	public void setDealer(Player d) {
		dealer = d;
	}
	
	/** Creates new form WarGUI */
	public BlackJackGUI() {
		//System.out.prinln("Starting War GUI");
		gameLogic = new BlackJack("Player", this);
		initComponents(); 
	}
	
	
	/**
	 * Initializes all of the components
	 */
	private void initComponents() {
		//System.out.prinln("INITIALIZING COMPONENTS");
		//Setting up the JFrame
		playerMoney = gameLogic.getHumanPlayer().getScore();;
		playerBet = 0;
		inRound = false;
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setSize(new Dimension(1000, 730));
		
		//Setting up the menus
		/*menuBar = new JMenuBar();
		
		menu = new JMenu("File");
		menu.setMnemonic(KeyEvent.VK_A);
		menuBar.add(menu);
		
		menuItem1 = new JMenuItem ("New Game" , KeyEvent.VK_T);
		menuItem1.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
		menu.add(menuItem1);
		menuItem1.addActionListener(new TempListener());
		
		menuItem2 = new JMenuItem ("Quit", KeyEvent.VK_B);
		menuItem2.addActionListener(new TempListener());
		menu.add(menuItem2);
		
		menu = new JMenu("Help");
		menu.setMnemonic(KeyEvent.VK_H);
		menuBar.add(menu);
		
		menuItem3 = new JMenuItem ("How to play");
		menu.add(menuItem3);
		
		menuItem4 = new JMenuItem ("About");
		menu.add(menuItem4);
		
		this.setJMenuBar(menuBar);
		*/
		// Initializing the panels
		myPanel = new JPanel() {
			public void paintComponent(Graphics g) {
				ImageIcon icon = new ImageIcon(getImageURL("IMAGES/background2.PNG"));
				g.drawImage(icon.getImage(), 0, 0, null);
				setOpaque( false );
				super.paintComponent(g);
			}
		};
		//Setting up myPanel
		myPanel.setLayout(null);
		myPanel.setPreferredSize(new Dimension(980,610));
		chip1 = new JLabel();
		chip1.setIcon(new ImageIcon(getImageURL("IMAGES/CHIP1.PNG")));
		myPanel.add(chip1);
		chip1.setBounds(810, 495, 60, 50);
		chip1.addMouseListener(new mouseListener());
		chip2 = new JLabel();
		chip2.setIcon(new ImageIcon(getImageURL("IMAGES/CHIP2.PNG")));
		myPanel.add(chip2);
		chip2.addMouseListener(new mouseListener());
		chip2.setBounds(870, 495, 60, 50);
		chip3 = new JLabel();
		chip3.setIcon(new ImageIcon(getImageURL("IMAGES/CHIP3.PNG")));
		myPanel.add(chip3);
		chip3.addMouseListener(new mouseListener());
		chip3.setBounds(780, 547, 60, 50);
		chip4 = new JLabel();
		chip4.setIcon(new ImageIcon(getImageURL("IMAGES/CHIP4.PNG")));
		myPanel.add(chip4);
		chip4.addMouseListener(new mouseListener());
		chip4.setBounds(840, 547, 60, 50);
		chip5 = new JLabel();
		chip5.setIcon(new ImageIcon(getImageURL("IMAGES/CHIP5.PNG")));
		myPanel.add(chip5);
		chip5.addMouseListener(new mouseListener());
		chip5.setBounds(900, 547, 60, 50);

		hitLabel = new JLabel ();
		hitLabel.setIcon(new ImageIcon(getImageURL("IMAGES/hitButton.PNG")));
		myPanel.add(hitLabel);
		hitLabel.addMouseListener(new mouseListener());
		hitLabel.setBounds(350, 557, 82, 32);
		
		standLabel = new JLabel();
		standLabel.setIcon(new ImageIcon(getImageURL("IMAGES/standButton.PNG"), ""));
		myPanel.add(standLabel);
		standLabel.addMouseListener(new mouseListener());
		standLabel.setBounds(470, 557, 90, 32);
		
		JLabel balance = new JLabel ("Current Balance");
		balance.setFont(new Font("Serif", Font.BOLD, 30));
		balance.setForeground(Color.BLACK);
		myPanel.add(balance);
		balance.setBounds(720, 30, 250, 30);
		
		JLabel betAmount = new JLabel("Bet Amount");
		betAmount.setFont(new Font("Serif", Font.BOLD, 26));
		betAmount.setForeground(Color.BLACK);
		myPanel.add(betAmount);
		betAmount.setBounds(600, 520, 200, 30);

		
		totalMoney = new JButton();
		totalMoney.setText(String.valueOf(playerMoney));
		totalMoney.setFont(new Font("Serif", Font.BOLD, 30));
		totalMoney.setBorderPainted(false);
		totalMoney.setEnabled(false);
		totalMoney.setForeground(Color.WHITE);
		totalMoney.setBackground(Color.BLACK);
		myPanel.add(totalMoney);
		totalMoney.setBounds(755, 75, 150, 50);
		
		betButton = new JButton();
		betButton.setText(String.valueOf(playerBet));
		betButton.setFont(new Font("Serif", Font.BOLD, 22));
		betButton.setBorderPainted(false);
		betButton.setEnabled(false);
		betButton.setForeground(Color.WHITE);
		betButton.setBackground(Color.BLACK);
		myPanel.add(betButton);
		betButton.setBounds(630, 560, 100, 30);
		
		dealLabel = new JLabel();
		dealLabel.setIcon(new ImageIcon(getImageURL("IMAGES/dealButton.PNG")));
		myPanel.add(dealLabel);
		dealLabel.addMouseListener(new mouseListener());
		dealLabel.setBounds(800, 430, 150, 50);
		initCards();
		initAnimationSteps();
		movingCard = new CardLabel(50, 420, getImage(null));
		//myPanel.add(movingCard);
		//movingCard.setBounds(movingCard.getHorizontalCoordinate(),
			//	movingCard.getVerticalCoordinate(), 100, 125);
		JLabel tableBackground = new JLabel ("BLACKJACK PAYS 3 TO 2");
		myPanel.add(tableBackground);
		tableBackground.setFont(new Font("Serif", Font.BOLD, 28));
		tableBackground.setForeground(Color.BLACK);
		tableBackground.setBounds(280, 165, 400, 50);
		
		JLabel tableBackground1 = new JLabel ("Dealer Draws to 17");
		myPanel.add(tableBackground1);
		tableBackground1.setFont(new Font("Serif", Font.BOLD, 18));
		tableBackground1.setForeground(Color.BLACK);
		tableBackground1.setBounds(370, 200, 300, 50);
		
		JLabel dHandValue = new JLabel("Dealer's Hand Value: ");
		dHandValue.setFont(new Font("Serif", Font.BOLD, 16));
		myPanel.add(dHandValue);
		dHandValue.setForeground(Color.WHITE);
		dHandValue.setBounds(200, 270, 200, 50);
		
		dealerHandValue = new JLabel ();
		myPanel.add(dealerHandValue);
		dealerHandValue.setFont(new Font("Serif", Font.BOLD, 20));
		dealerHandValue.setForeground(Color.WHITE);
		dealerHandValue.setBounds(370, 270, 200, 50);
		
		JLabel pHandValue = new JLabel ("Player's Hand Value: ");
		pHandValue.setFont(new Font("Serif", Font.BOLD, 16));
		myPanel.add(pHandValue);
		pHandValue.setForeground(Color.WHITE);
		pHandValue.setBounds(200, 410, 200, 50);
		
		playerHandValue = new JLabel ();
		myPanel.add(playerHandValue);
		playerHandValue.setFont(new Font("Serif", Font.BOLD, 20));
		playerHandValue.setForeground(Color.WHITE);
		playerHandValue.setBounds(370, 410, 200, 50);
		
		playerBust = new JLabel("Player Bust");
		myPanel.add(playerBust);
		playerBust.setFont(new Font("Serif", Font.BOLD, 30));
		playerBust.setForeground(Color.WHITE);
		playerBust.setBounds(560, 365, 200, 50);
		playerBust.setVisible(false);
		
		playerWinner = new JLabel ("Player Won");
		myPanel.add(playerWinner);
		playerWinner.setFont(new Font("Serif", Font.BOLD, 30));
		playerWinner.setForeground(Color.WHITE);
		playerWinner.setBounds(560, 365, 200, 50);
		playerWinner.setVisible(false);
		
		dealerBust = new JLabel("Dealer Bust");
		myPanel.add(dealerBust);
		dealerBust.setFont(new Font("Serif", Font.BOLD, 30));
		dealerBust.setForeground(Color.WHITE);
		dealerBust.setBounds(560, 365, 200, 50);
		dealerBust.setVisible(false);
		
		dealerWinner = new JLabel("Dealer Won");
		myPanel.add(dealerWinner);
		dealerWinner.setFont(new Font("Serif", Font.BOLD, 30));
		dealerWinner.setForeground(Color.WHITE);
		dealerWinner.setBounds(560, 365, 200, 50);
		dealerWinner.setVisible(false);
		
		deck = new CardLabel (50, 420, getImage(null));
		myPanel.add(deck);
		deck.setBounds(420, 50, 100, 125);
		deck.setVisible(false);
		
		this.getContentPane().add(myPanel); 
		pack();
	}
	
	public void setDealerHand(Hand dealer) {
		dealerCards = dealer;
	}
	
	public void playerBust() {
		playerBust.setVisible(true);
	}
	
	public void playerWinner() {
		playerWinner.setVisible(true);
	}
	
	public void dealerBust() {
		dealerBust.setVisible(true);
	}
	
	public void dealerWinner() {
		dealerWinner.setVisible(true);
	}
	
	public static URL getImageURL(String imageName) {
		URL imageURL = null;
		try {
			Class cardClass = Class.forName("BlackJackGUI");
			URL classURL = cardClass.getResource("BlackJackGUI.class");
			imageURL = new URL(classURL, imageName);
		} catch (Exception e) {
			System.out.println(e);
			System.exit(0);
		}
		return imageURL;
	}
	
	public void initAnimationSteps() {
		int computerStartY = 50;
		for (int i = 0; i < computerMoves.length; i++) {
			computerMoves[i] = new CardLabel (computerStartY, 420, getImage(null));
			computerMoves[i].setBounds(computerMoves[i].getHorizontalCoordinate(),
					computerMoves[i].getVerticalCoordinate(), 100, 125);
			myPanel.add(computerMoves[i]);
			computerMoves[i].setVisible(false);
			computerStartY += 42;
		}
		int playerStartY = 50;
		for (int i = 0; i < playerMoves.length; i++) {
			playerMoves[i] = new CardLabel (playerStartY, 420, getImage(null));
			playerMoves[i].setBounds(playerMoves[i].getHorizontalCoordinate(),
					playerMoves[i].getVerticalCoordinate(), 100, 125);
			myPanel.add(playerMoves[i]);
			playerMoves[i].setVisible(false);
			playerStartY += 70;
		}
	}
	
	/**
	 * Updates the balance showing on the screen
	 * @param value the updated balance
	 */
	public void updateBalance(int value) {
		totalMoney.setText(String.valueOf(value));
	}
	
	public void updatePlayersHandValue(int value) {
		if (value == 0) {
			playerHandValue.setText("");
		} else {
			playerHandValue.setText(String.valueOf(value));
		}
	}
	
	public void updateDealersHandValue(int value) {
		//System.out.println("Value: " + value);
		if (value == 0) {
			dealerHandValue.setText("");
		} else {
			dealerHandValue.setText(String.valueOf(value));
		}
	}	
	public void animateCard() {
		//System.out.println("IN animateCard()");
		if (playerCardMoving) {
			//System.out.println(" For Player");
		} else {
			//System.out.println(" FOR DEALER");
		}
		timer = new Timer(50, timerListener);
		animating = true;
		timer.start();
	}
	
	
	public void updateBet(int value) {
		betButton.setText(String.valueOf(value));
	}
	
	public void initCards() {
		int startPosition = 420;
		for (int i = 0; i < computerHand.length; i++) {
			computerHand[i] = new CardLabel(260, startPosition, getImage(null));
			computerHand[i].setHasCard(false);
			myPanel.add(computerHand[i]);
			computerHand[i].setBounds(computerHand[i].getHorizontalCoordinate(),
					computerHand[i].getVerticalCoordinate(), 100, 125);
			computerHand[i].setVisible(false);
			startPosition += 15;
		}
		startPosition = 420;
		for (int i = 0; i < playerHand.length; i++) {
			playerHand[i] = new CardLabel(400, startPosition, getImage(null));
			playerHand[i].setHasCard(false);
			myPanel.add(playerHand[i]);
			playerHand[i].setBounds(playerHand[i].getHorizontalCoordinate(),
					playerHand[i].getVerticalCoordinate(), 100, 125);
			playerHand[i].setVisible(false);
			startPosition += 15;
		}
	}
	
	public void showDealedCards(Player p, Player d) {
		playerCards = p.getHand();
		dealerCards = d.getHand();
		//System.out.println("In ShowDealedCards");
		//System.out.println("playerCards.getSize(): " + playerCards.size());
		//System.out.println("DealerCards.getSize(): " + dealerCards.size());
		playerPileLocation = playerCards.size() - 1;
		dealerPileLocation = dealerCards.size() - 1;
		////System.out.println("PlayerPileLocation = " + playerPileLocation);
		////System.out.println("DealerPileLocation = " + dealerPileLocation);
		playerCardMoving = true;
		count = 0;
		stepCount = 0;
		locationMovingTo = 0;
		animateCard();
	}
	
	
	
	/**
	 * Returns the image that corresponds to the input card.
	 * 
	 * @param c Card to get the image for
	 * @return String representation of the image
	 */
	public String getImage(Card c) {	
			if (c == null) {
				String temp = "IMAGES/BACK1.JPG";
				return temp;
			} else if(c.getFaceUp()) {
				String str = "IMAGES/CARDS/";
				int rank = ((Integer)c.getRank().getValues().get(0)).intValue();
				String rankStr = rank + "";
				if (rank >= 10) {
					if (rank == 11) {
						rankStr = "J";
					} else if (rank == 12) {
						rankStr = "Q";
					} else if (rank == 13) {
						rankStr = "K";
					} else if (rank == 14) {
						rankStr = "A";
					}
				}
			
				String suit = "";
				if (c.getSuit().equals("Hearts")) {
					suit = "H";
				} else if (c.getSuit().equals("Diamonds")) {
					suit = "D";
				} else if (c.getSuit().equals("Spades")) {
					suit = "S";
				} else {
					suit = "C";
				}
				str += rankStr;
				str += suit;
				str += ".GIF";
				return str;
			}
			else {
				String temp = "IMAGES/BACK1.JPG";
				return temp;
			}
	}

	public void setPlayerCards(CardPile c) {
		for (int i = 0; i < c.size(); i++) {
			addCardToFrontPlayer(c.getCardAt(i));
		}
	}

	
	public void setDealerCards(CardPile c) {
		for (int i = 0; i < computerHand.length; i++) {
			if(i < c.size()) {
				////System.out.println("Setting new image");
				computerHand[i].setIcon(new ImageIcon(getImageURL(getImage(c.getCardAt(i)))));
				computerHand[i].setHasCard(true);
			} else {
				computerHand[i].setHasCard(false);
			}
		}
	}
	
	public void addCardToFrontDealer(Card c) {
		////System.out.println("IN add Card to Front Dealer");
		for (int i = (computerHand.length - 1); i > 0; i--) {
			computerHand[i].setIcon(computerHand[i - 1].getIcon());
			if (computerHand[i - 1].hasCard()) {
				////System.out.println("Dealer card at (i -1) had card: ");
				computerHand[i].setHasCard(true);
				////System.out.println("Set computer hand at : " + i + " to has card true");
			} else {
				////System.out.println("Player did not have card at: " + i);
			}
		}
		String image = getImage(c);
		////System.out.println("Added Card: " + image + " to Front");
		computerHand[0].setIcon(new ImageIcon(getImageURL(image)));
		computerHand[0].setHasCard(true);
		for (int i = 0; i < computerHand.length; i++) {
			////System.out.println("Setting visible to true");
			if (computerHand[i].hasCard()) {
				////System.out.println("Computer hand at : " + i + " had card");
				computerHand[i].setVisible(true);
			}
		}
	}
	
	public void addCardToFrontPlayer(Card c) {
		////System.out.println("IN add Card to Front Player");
		for (int i = (playerHand.length - 1); i > 0; i--) {
			playerHand[i].setIcon(playerHand[i - 1].getIcon());
			if (playerHand[i - 1].hasCard()) {
				////System.out.println("Player card at (i -1) had card: ");
				playerHand[i].setHasCard(true);
				////System.out.println("Set player hand at : " + i + " to has card true");
			} else {
				////System.out.println("Player did not have card at: " + i);
			}
		}
		String image = getImage(c);
		////System.out.println("Added Card: " + image + " to Front");
		playerHand[0].setIcon(new ImageIcon(getImageURL(image)));
		playerHand[0].setHasCard(true);
		for (int i = 0; i < playerHand.length; i++) {
			//////System.out.println("Setting visible to true");
			if (playerHand[i].hasCard()) {
				////System.out.println("Player hand at : " + i + " had card");
				playerHand[i].setVisible(true);
			}
		}
	}
	
	public void playerHit(Card c, Hand pHand) {
		//System.out.println("Player hit dealer Size: " + dealerCards.size());
		playerCards = pHand;
		hitCard = c;
		stepCount = 0;
		playerCardMoving = true; 
		timer3 = new Timer(50, timerListener3);
		////System.out.println("Starting Timer from player Hit");
		animating = true;
		timer3.start();
	}
	
	public void dealerHit() {
		//System.out.println("Dealer Hit Called");
		stepCount = 0;
		playerCardMoving = false;
		//System.out.println("Dealer Hit Count: " + dealerHitCount);
		hitCard = dealerCards.getCardAt(dealerHitCount);
		////System.out.println("HIT CARD: " + hitCard.toString());
		dealerHitCount--;
		timer3 = new Timer(50, timerListener3);
		////System.out.println("Starting timer from dealerHit");
		animating = true;
		timer3.start();
	}
	
	public void allDealerHits(Hand dHand) {
		for (int i = 0; i < dHand.size(); i++) {
			//System.out.println(dHand.getCardAt(i).toString());
		}
		dealerHitCount = dHand.size() - 3;
		if (dealerHitCount < 0) {
			updateDealersHandValue(dHand.calculateValue());
			 gameLogic.determineWinner();
		} else {
			dealerCards = dHand;
			//System.out.println("Dealer Cards size 1: " + dealerCards.size());
			dealerHit();
		}
	}
	
	public void setDealerCardsFaceUp(Hand dealerHand) {
		////System.out.println("Setting CARDS FACE UP");
		for (int i = 0; i < dealerHand.size(); i++) {
			
			String image = getImage(dealerHand.getCardAt(i));
			////System.out.println("IMAGE: " + image);
			computerHand[i].setIcon(new ImageIcon(getImageURL(image)));
			//computerHand[i].setVisible(false);
			//computerHand[i].setVisible(true);
		}
		//myPanel.repaint();
	}
	
	public void hideCards() {
		for (int i = 0; i < playerHand.length; i++) {
			playerHand[i].setVisible(false);
			playerHand[i].setHasCard(false);
		}
		for (int i = 0; i < computerHand.length; i++) {
			computerHand[i].setVisible(false);
			computerHand[i].setHasCard(false);
		}
		dealerWinner.setVisible(false);
		dealerBust.setVisible(false);
		playerWinner.setVisible(false);
		playerBust.setVisible(false);
		myPanel.repaint();
	}
	

	public void dealerCardAnimation() {
		timer2 = new Timer(1000, timerListener2);
		displayCount = 0;
		animating = true;
		timer2.start();
	}
	

	/**
	 * Action Listener for the timer
	 */
	ActionListener timerListener2 = new ActionListener() {
		
		
		public void actionPerformed(ActionEvent evt) {
			////System.out.println("TIMER FIRED");
			////System.out.println("DealerHand size: " + dealer.getHand().size());
			if (displayCount < dealer.getHand().size()) {
				if (displayCount == 0) {
					setDealerCardsFaceUp(dealer.getHand());
				} else {
					computerHand[displayCount].setVisible(true);
				}
				displayCount++;
			} else {
				////System.out.println("STOPPING TIMER");
				timer2.stop();
				animating = false;
				displayCount = 0;
			}
			
		}
	};
	
	ActionListener timerListener3 = new ActionListener() {
		public void actionPerformed (ActionEvent evt) {			
			if (stepCount == numberOfSteps) {
				////System.out.println("Stopping timer");
				timer3.stop();
				animating = false;
				//System.out.println("Dealer size: " + dealerCards.size());
				//System.out.println("Dealer Hit Count: " + dealerHitCount);
				if (playerCardMoving) {
					playerMoves[stepCount -1].setVisible(false);
					stepCount = 0;
					addCardToFrontPlayer(hitCard);
					updatePlayersHandValue(playerCards.calculateValue());
					//System.out.println("DEALER SIZE: " + dealerCards.size());
				} else {
					computerMoves[stepCount -1 ].setVisible(false);
					stepCount = 0;
					addCardToFrontDealer(hitCard);
					updateDealersHandValue(dealerCards.calculateValue());
				}
				if (dealerHitCount >= 0 && !playerCardMoving) {
					//System.out.println("About to call dealers hit");
					dealerHit();
				} else {
					if (!playerCardMoving) {
						gameLogic.determineWinner();
					}
				}
			} else {
				////System.out.println("Animating");
				if (playerCardMoving) {
					playerMoves[stepCount].setVisible(true);
					if (stepCount != 0) {
						playerMoves[stepCount -1].setVisible(false);
					} 
				} else {
					computerMoves[stepCount].setVisible(true);
					if (stepCount != 0) {
						computerMoves[stepCount - 1].setVisible(false);
					}
				}
				stepCount++;
			}
		}
	};
	
	/**
	 * Action listener for the timer
	 */
	ActionListener timerListener = new ActionListener() {
		// Define an action listener to respond to events
		// from the timer.  When an event is received, the
		// color of the display is changed.
		public void actionPerformed(ActionEvent evt) {
			if ( stepCount == numberOfSteps) {
				////System.out.println("Step Count = numberOfSteps");
				if (playerCardMoving) {
					////System.out.println("Player Card Was Moving");
					playerMoves[stepCount -1].setVisible(false);
				} else {
					////System.out.println("Dealer Card was Moving");
					computerMoves[stepCount - 1].setVisible(false);
				}
				if (count == 10) {
					count = 0;
					stepCount = 0;
					////System.out.println("Count == 20");
					timer.stop();
					animating = false;
					if (playerCardMoving) {
						playerPileLocation --;
						////System.out.println("Decrementing PlayerPileLocation to : " + playerPileLocation);
						playerCardMoving = false;
						animateCard();
					} else {
						dealerPileLocation --;
						////System.out.println("Decrementing DealerPileLocation to: " + dealerPileLocation);
						if (playerPileLocation < 0 && dealerPileLocation < 0) {
							//System.out.println("Done dealing cards");
							//done dealing cards
							updatePlayersHandValue(playerCards.calculateValue());
						}  else {
							playerCardMoving = true;
							animateCard();
						}
					}
				} else if (count == 0) {
					////System.out.println("COunt == 0");
					if (playerCardMoving) {
						addCardToFrontPlayer(playerCards.getCardAt(playerPileLocation));
					} else {
						addCardToFrontDealer(dealerCards.getCardAt(dealerPileLocation));
					}
					count++;
				} else {

					////System.out.println("About to increment Count");
					count++;
				}
				} else {
					//System.out.println("Count shoul not incrment");
				if (playerCardMoving) {
					playerMoves[stepCount].setVisible(true);
					if (stepCount != 0) {
						playerMoves[stepCount -1].setVisible(false);
					} 
				} else {
					computerMoves[stepCount].setVisible(true);
					if (stepCount != 0) {
						computerMoves[stepCount - 1].setVisible(false);
					}
				}
				stepCount++;
			}
			
		}
	}; 
	
	
	
	/**
	 * Class for the mouse listeners
	 * @author Allison Jensen
	 *
	 */
	private class mouseListener implements MouseListener {
		public void mouseClicked(MouseEvent e) {
			if (!animating) {
				if (e.getSource().equals(dealLabel)) {
					if (!inRound) {
						hideCards();
						inRound = true;
						gameLogic.dealCards(Integer.valueOf(betButton.getText()).intValue());
						updateBalance(gameLogic.getHumanPlayer().getScore());
						updatePlayersHandValue(0);
						updateDealersHandValue(0);
					}
				} else if (e.getSource().equals(hitLabel)) {
					if (inRound) {
						gameLogic.playerHit();
					}
				} else if (e.getSource().equals(standLabel)) {
					if (inRound) {
						gameLogic.playerStand();
					}
				} else if (e.getSource().equals(chip1)) {
					playerBet = 1;
					betButton.setText(String.valueOf(playerBet));
				
			} else if (e.getSource().equals(chip2)) {
				playerBet = 2;
				betButton.setText(String.valueOf(playerBet));
				
			} else if (e.getSource().equals(chip3)) {
				playerBet = 3;
				betButton.setText(String.valueOf(playerBet));
				
			} else if (e.getSource().equals(chip4)) {
				playerBet = 4;
				betButton.setText(String.valueOf(playerBet));
				
			} else if (e.getSource().equals(chip5)) {
				playerBet = 5;
				betButton.setText(String.valueOf(playerBet));
				
			}
			}
			
		}
		
		public void mouseExited (MouseEvent e) {
			
		}
		
		public void mouseReleased (MouseEvent e) {
			
		}
		
		public void mouseEntered (MouseEvent e) {
			
		}
		
		public void mousePressed (MouseEvent e) {
			
		}
	}
	 
	/**
	 * Class to handle menu item actions
	 * @author Allison Jensen
	 *
	 */
	private class TempListener implements ActionListener {
		
		/** Creates an instance of the TempListener */
		public TempListener() {
		} //end of TempListener()
		
		
		/**
		 * A method to implement what to do when a listener is activated
		 * @param e the action event that set off the listener
		 */
		public void actionPerformed(ActionEvent e) {
			if (e.getSource().equals(menuItem1)) {        	
			} else if (e.getSource().equals(menuItem2)) {
				System.exit(0);
			} else if (e.getSource().equals(menuItem3)) {
				
			} else if (e.getSource().equals(menuItem4)) {
				
			}
		}
	}//end of class tempListener
	
	
	/**
	 * Main Method
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		java.awt.EventQueue.invokeLater(new Runnable() {
			public void run() {
				new BlackJackGUI().setVisible(true);
			}
		});
	}
	
	
}
