 /**
 * The <code>Deck</code> class represents the deck that is used during
 * regular Blackjack gameplay. Because there may be several <code>Decks</code>
 * used in the game this class it taken out of <code>CardPile</code>.
 * 
 * @author <a href="mailto:">veronica@gatech.edu</a>
 * @version 1.0
 */

public class Deck extends CardPile {


	public void fillDeck() 
	{

	
		Rank two = new Rank("two", 2);
		Rank three = new Rank("three", 3);
		Rank four = new Rank("four", 4);
		Rank five = new Rank("five", 5);
		Rank six = new Rank("six", 6);
		Rank seven = new Rank("seven", 7);
		Rank eight = new Rank("eight", 8);
		Rank nine = new Rank("nine", 9);
		Rank ten = new Rank("ten", 10);
		Rank jack = new Rank("Jack", 10);
		Rank queen = new Rank("Queen", 10);
		Rank king = new Rank("King", 10);

		int[] aceValues = {1,11};
		Rank ace = new Rank("Ace", aceValues);

		Rank[] ranks = 
			{
				two, three, four, five, six, seven, eight, nine, ten,
				jack, king, queen, ace};

		for(int i = 0; i < 13; i++)
		{
			this.addCard(new Card(ranks[i], "Hearts"));
			this.addCard(new Card(ranks[i], "Spades"));
			this.addCard(new Card(ranks[i], "Clubs"));
			this.addCard(new Card(ranks[i], "Diamonds"));
		}

			
	}

}
