  import java.util.ArrayList;

/**
 * The <code>Hand</code> class represents the player's hand during a game.
 * <code>Hand</code> creates a new <code>CardPile</code> and then calculates
 * it's value for the user
 *
 * @author <a href="mailto:">veronica@gatech.edu</a>
 * @version 1.0
 */

public class Hand extends CardPile implements Comparable 
{

	private CardPile hand = new CardPile();

	public CardPile getHand()
	{
		return hand;
	}

	public void setHand(CardPile newHand)
	{
		this.hand = newHand;
	}

	public int compareTo(Object anotherHand)
	{
	
		int less = -1;
		int equal = 0;
		int greater = 1;

		if (this.calculateValue() == ((Hand)anotherHand).calculateValue())
			return equal;
		else if (this.calculateValue() > ((Hand)anotherHand).calculateValue())
			return greater;
		else
			return less;
	}

																		 

	public int calculateValue()
	{
		
		int length = this.size();
		int handValue = 0;
		int i = 0;
		boolean hasAce = false;

		for(i = 0; i < length; i++)
		{
			if(this.getCardAt(i).getRank().getName() == "Ace")
				hasAce = true;
		}

		for(i = 0; i < length; i++) 
		{
			handValue = handValue + 
				((Integer)this.getCardAt(i).getRank().getValues().get(0)).intValue();
		}

		if(hasAce && (handValue <=11))
			handValue += 10;
		
		//System.out.println("Returning Hand Value: " + handValue);
	
		return handValue;

	}

		

	
}// end Hand
