import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * This class shows a random fortune from an array of fortunes.  Use the next
 * button to see the next random fortune.
 * 
 * 
 * @author Barb Ericson
 * Copyright 2004 Georgia Tech
 */
public class FortuneTellerPanel extends JPanel implements ActionListener
{
  /////////////// Fields ////////////////////////////
  private String[] fortunes = {"You will win the lottery!",
                               "You will meet a dark stranger.",
                               "You will hurt your ankle.",
                               "You will get an A in this class.",
                               "You will take a trip soon.",
                               "You will have car trouble.",
                               "You will not get enough sleep.",
                               "You will create a cool video game.",
                               "You will run a marathon.",
                               "You will go to the Olympics!"
                                };
  private JButton nextButton = new JButton("Next");
  
  /////////////////// Constructors ////////////////////////
  
  /**
   * No argument constructor 
   */
  public FortuneTellerPanel () 
  {
    // initialize the panel
    initialize();
  }
  
  ////////////////////// Methods ///////////////////////////////
  
  /**
   * Method to initialize this panel
   */
  public void initialize()
  {
    // set the layout to border layout
    this.setLayout(new BorderLayout());
    
    // set up the fortune panel with a label and textfield
    JPanel fortunePanel = new JPanel();
    // code to add label
    // code to add textfield
    
    // set up the button panel
    JPanel buttonPanel = new JPanel();
    nextButton.addActionListener(this);
    buttonPanel.add(nextButton);
    
    // add to this panel
    this.add(fortunePanel,BorderLayout.NORTH);
    this.add(buttonPanel,BorderLayout.SOUTH);
  }
  
  /**
   * Method to get a random fortune from the array of fortunes
   * @return a string that is the fortune pulled at random from the array
   */
  public String getRandomFortune()
  {
    int index = (int) (Math.random() * fortunes.length);
    return fortunes[index];
  }
  
  /**
   * Method to handle action events
   */
  public void actionPerformed(ActionEvent evt)
  {
    // code to set the textfield text to a random fortune from the array
  }
  
  /**
   * Main method for running as an application
   */
  public static void main(String[] argv) 
  {
    FortuneTellerPanel fortuneTeller = new FortuneTellerPanel();
    JFrame frame = new JFrame("Fortune Teller");
    frame.getContentPane().add(fortuneTeller);
    frame.pack();
    frame.setVisible(true);
  }
}
    
    