import java.util.Random;

public class NumberGuessGame
{
  //////////////// fields //////////////////
  private int maxNum = 100;
  private int minNum = 1;
  private Random randomNumGen = new Random();
  private int pickedNum;
  private int numGuesses = 0;
  
  //////////// constructors /////////////////
  
  public NumberGuessGame()
  {
    this.pickedNum = this.randomNumGen.nextInt(this.maxNum - 
                                       this.minNum + 1);
    this.pickedNum = this.pickedNum + this.minNum;
  }
  
  public NumberGuessGame(int min, int max)
  {
    this.minNum = min;
    this.maxNum = max;
    this.pickedNum = this.randomNumGen.nextInt(this.maxNum - 
                                       this.minNum + 1);
    this.pickedNum = this.pickedNum + this.minNum;
  }
  
  public String toString()
  {
    return "Picked num: " + this.pickedNum;
  }
  
  public void playGame()
  {
    boolean done = false;
    
    // loop till guess is correct
    while (!done)
    {
    // need to get a guess from the user
      int guess = SimpleInput.getIntNumber("Pick a number "+
                    "between " + this.minNum + " and " +
                    this.maxNum);
      
      // incremented the number of guesses
      this.numGuesses = this.numGuesses + 1;
      
    // we need to check the guess (compare to pickedNum)
      if (guess == this.pickedNum)
      {
        // tell the user she/he was right
        SimpleOutput.showInformation("That was right! " +
                                     "It took you " +
                                     this.numGuesses);
        done = true;
      }
      else if (guess < this.pickedNum)
      {
      // we need to tell the user too low
        SimpleOutput.showInformation("Too low");
      }
      else
      {
        // tell the user the guess is too high
        SimpleOutput.showInformation("Too high");
      }
    }
  }
  
  public static void main(String[] args)
  {
    NumberGuessGame game = new NumberGuessGame();
    game.playGame();
  }

  }