
/**
 * Class that represents information about a picture, such as the file name and a caption
 * @author Barb Ericson
 * Copyright 2004 Georgia Institute of Technology
 */
public class PictureInfo
{
  ///////////////// fields /////////////////////////////
  
  /** the file name for the picture */
  private String fileName;
  
  /** the caption for the picture */
  private String caption;
  
  /////////////// constructors /////////////////////////
  
  /**
   * No argument constructor.  All fields will be their default values 
   */
  public PictureInfo() {}
  
  /**
   * Constructor that takes the file name and caption 
   */
  public PictureInfo(String fileName, String caption)
  {
    this.fileName = fileName;
    this.caption = caption;
  }
  
  ///////////////// methods ///////////////////////////////////
  
  /**
   * Method to get the fileName
   * @return the file name for the picture
   */
  public String getFileName() { return fileName; }
  
  /**
   * Method to get the caption 
   * @return the caption
   */
  public String getCaption() { return caption; }
  
  /**
   * Method to set the caption
   * @param theCaption the new caption
   */
  public void setCaption(String theCaption) { caption = theCaption; }
  
}
  
