
/**
 * Class that represents an animal
 * @author Barb Ericson
 * Copyright 2006
 */
public abstract class Animal implements NoisyItem
{
  /////////// fields ////////////////////
  
  /** the noise an animal can make */
  private Sound noise;
  
  /** a picture of the animal */
  private Picture picture; 
  
  ///////////// Constructors ////////////////
  
  /**
   * A constructor that takes a sound 
   * @param theNoise the noise the animal makes 
   */
  public Animal(Sound theNoise)
  {
    this.noise = theNoise;
  }
  
  /**
   * A constructor that takes a picture and sound
   * @param thePicture a picture of the animal
   * @param theNoise the sound the animal makes 
   */
  public Animal(Picture thePicture, Sound theNoise)
  {
    this.picture = thePicture;
    this.noise = theNoise;
  }
  
  //////////// methods ///////////////////////
  
  /**
   * Method to make an animal make the noise
   */
  public void makeNoise()
  {
    if (this.picture != null)
      this.picture.show();
    if (this.noise != null)
    {
      System.out.println("A " + 
                         this.getClass().getName() + 
                         " says");
      noise.play();
    }
  }
}
  
  