import javax.swing.*;
import java.awt.event.*;
import java.util.*;
import java.awt.FlowLayout;
import java.awt.Container;

/**
 * Class that can dipslay a See N Say
 * @author Barb Ericson
 * Copyright 2006
 */
public class SeeNSayDisplay extends JPanel 
  implements ActionListener
{
  /////////// fields //////////////////
  
  /** See N Say Model */
  private SeeNSay model = new SeeNSay("seensay.txt");
  
  ///////// constructor //////////////
  
  /**
   * Constructor that takes no arguments 
   */
  public SeeNSayDisplay() 
  {
    this.setLayout(new FlowLayout());
    List<String> nameList = model.getNameList();
    for (String name : nameList)
    {
      JButton button = new JButton(name);
      button.addActionListener(this);
      this.add(button);
    }
  }
  
  /**
   * Method to handle an action event 
   * @param e an action event
   */
  public void actionPerformed(ActionEvent e)
  {
    JButton button = (JButton) e.getSource();
    model.pickItem(button.getText()); 
  }
  
  public static void main(String[] args)
  {
    JFrame frame = new JFrame("See N Say");
    Container pane = frame.getContentPane();
    pane.add(new SeeNSayDisplay());
    frame.pack();
    frame.setVisible(true);
  }
}