import junit.framework.TestCase;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class CustomerTest extends TestCase {
  
  /**
   * A test method.
   * Tests that only the owner of an account can make a withdrawal.
   */
  public void testWithdrawal() {
    // create a customer and a pirate customer
    Customer customer = new Customer("Barbara", "Ericson", 300);
    Customer pirateCustomer = new Customer("Edward", "Teach", 0);
    
    // get the customer's bank account and the pirate bank account
    BankAccount account = customer.getAccount();
    BankAccount pirateAccount = pirateCustomer.getAccount();
    
    // check the amount in each account
    assertTrue("Check of cusomter amount after constructor",
               account.getBalance() == 300);
    assertTrue("Check of pirate balance after constructor ",
               pirateAccount.getBalance() == 0);
    
    // change the account balance in the customer account
    double amount = account.withdraw(pirateCustomer,200);
    pirateAccount.deposit(amount);
    
    // check the amount in each account
    assertTrue("Check of customer balance after pirate attack",
               account.getBalance() == 300);
    assertTrue("Check of pirate balance after pirate attack",
               pirateAccount.getBalance() == 0);
  }
  
}
