import java.awt.*;

/**
 * Class Line:  inherits from Shape and handles a line
 * @author Barb Ericson
 */
public class Line extends Shape
{
  
  ///////////////////// Constructors ///////////////////////////////
  
  /** No argument constructor */
  public Line ()
  {
    super();  // use parent constructor
  }
  
  /**
   * Constructor that takes two points
   * @param firstPoint  the first point for defining the shape
   * @param lastPoint   a second point for defining the shape
   */
  public Line (Point firstPoint, Point lastPoint)
  {
    super(firstPoint,lastPoint); // use shape constructor
  }
  
  /**
   * Constructor that takes x1,y1,x2,y2
   * @param x1  x value for the first point for defining the shape
   * @param y1  y value for the first point defining the shape
   * @param x2  x value for the second point defining the shape
   * @param y2  y value for the second point defining the shape
   */
  public Line (int x1, int y1, int x2, int y2)
  {
    super(x1,y1,x2,y2);  // use shape constructor
  }
  
  //////////////////////// Public Methods //////////////////////////////
  
  /**
   * Draw the shape
   * @param g   the graphics context to draw to
   */
  public void draw(Graphics g)
  {
    // set the color to draw the shape in
    g.setColor(color);
    
    // draw the line given the x and y value of one point
    // and the x and y value of the other point
    g.drawLine(p1.x,p1.y,p2.x,p2.y);
  }
  
}


